/*
 * Copyright (C) 2009 National Marrow Donor Program. All Rights Reserved.
 */

package net.agnis.cadsrapi41

class ClassificationSchemeItemRetrieverFactory
extends RetrieverFactory
{
    ClassificationSchemeItemRetrieverFactory()
    {
        super()
    }

    def newRetriever(propertyName)
    {
        def instance = null;

        switch(propertyName)
        {
            case 'classificationScheme' :
                instance = new Target('ClassificationScheme')
                instance.addPropertyName('classSchemeClassSchemeItemCollection')
                break;

            case 'classificationSchemeItem' :
                instance = new Target('ClassificationSchemeItem')
                break;

            case 'classSchemeClassSchemeItem' :
                instance = new Target('ClassSchemeClassSchemeItem')
                instance.orderBy = [ 'displayOrder', 'id' ]
                instance.addPropertyName('classificationSchemeItem')
                break;

            case 'classSchemeClassSchemeItemCollection' :
                instance = newRetriever('classSchemeClassSchemeItem')
                instance.oneToMany = true
                break;

            default :
                throw new IllegalArgumentException(
                    'Unrecognized property name: ' + propertyName)
        }

        assert instance != null
        instance.factory = this

        return instance
    }
}