/*
 * Copyright (C) 2009 National Marrow Donor Program. All Rights Reserved.
 */

package net.agnis.cadsrapi41

import javax.swing.ProgressMonitor

class CurationRetrieverFactory
extends RetrieverFactory
{
    CurationRetrieverFactory()
    {
        this(null, null)
    }

    CurationRetrieverFactory(ProgressMonitor progressMonitor, String progressClassName)
    {
        super(progressMonitor, progressClassName)
    }

    def newRetriever(propertyName)
    {
        def instance = null;

        switch(propertyName)
        {
            case 'administeredComponentClassSchemeItemCollection' :
                instance = new Association(propertyName)
                instance.oneToMany = true
                instance.addPropertyName('dataElement')
                break;

            case 'classSchemeClassSchemeItem' :
                instance = new Target('ClassSchemeClassSchemeItem')
                instance.orderBy = [ 'displayOrder', 'id' ]
                instance.addPropertyName('administeredComponentClassSchemeItemCollection')
                instance.addPropertyName('classificationScheme')
                instance.addPropertyName('classificationSchemeItem')
                break;

            case 'dataElement' :
                instance = super.newRetriever(propertyName)
                instance.addPropertyName('dataElementDerivationCollection')
                break;

            case 'dataElementConcept' :
                instance = super.newRetriever(propertyName)
                instance.addPropertyName('conceptualDomain')
                instance.addPropertyName('objectClass')
                instance.addPropertyName('property')
                break;

            case 'valueDomain' :
                instance = super.newRetriever(propertyName)
                instance.addPropertyName('conceptualDomain')
                instance.addPropertyName('represention')
                instance.addPropertyName('gov.nih.nci.cadsr.domain.jaxb.EnumeratedValueDomain::valueDomainPermissibleValueCollection')
                break;

            default :
                instance = super.newRetriever(propertyName)
        }

        assert instance != null
        instance.factory = this

        return instance
    }
}