/*
 * Copyright (C) 2009 National Marrow Donor Program. All Rights Reserved.
 */

package net.agnis.cadsrapi41.cxf;

import javax.xml.stream.XMLStreamReader;
import org.apache.cxf.phase.AbstractPhaseInterceptor;
import org.apache.cxf.phase.Phase;
import org.apache.cxf.interceptor.Fault;
import org.apache.cxf.interceptor.StaxInInterceptor;
import org.apache.cxf.message.Message;

public class PostStaxInInterceptor
extends AbstractPhaseInterceptor<Message>
{
    public PostStaxInInterceptor()
    {
        super(Phase.POST_STREAM);
        getAfter().add(StaxInInterceptor.class.getName());
    }

    public void handleMessage(Message message)
    throws Fault
    {
        WrappedXMLStreamReader reader = new WrappedXMLStreamReader(
            message.getContent(XMLStreamReader.class));
        assert reader != null;
        message.setContent(XMLStreamReader.class, reader);
    }
}
