/*
 * Copyright (C) 2009 National Marrow Donor Program. All Rights Reserved.
 */

package net.agnis.cadsrapi41.cxf;

import javax.xml.stream.XMLStreamReader;
import org.apache.cxf.staxutils.DepthXMLStreamReader;

public class WrappedXMLStreamReader
extends DepthXMLStreamReader
{
    public WrappedXMLStreamReader(XMLStreamReader reader)
    {
        super(reader);
    }

    protected boolean isUnqualifiedNamespaceRequired(int depth)
    {
        if(depth >= 3)
        {
            return true;
        }
        return false;
    }

    public javax.xml.namespace.QName getName()
    {
        javax.xml.namespace.QName qn = super.getName();
        if(isUnqualifiedNamespaceRequired(getDepth()))
        {
            qn = new javax.xml.namespace.QName("", qn.getLocalPart());
        }
        return qn;
    }

    public java.lang.String getNamespaceURI()
    {
        if(isUnqualifiedNamespaceRequired(getDepth()))
        {
            return null;
        }
        return super.getNamespaceURI();
    }
}
