/*
 * Copyright (C) 2009 National Marrow Donor Program. All Rights Reserved.
 */

package net.agnis.cadsrapi41.jaxb

class NamespacePrefixMapper
extends com.sun.xml.bind.marshaller.NamespacePrefixMapper
{
    final String CADSR_URI =
        'urn:domain.cadsr.nci.nih.gov'
    final String CADSRUML_URI =
        'urn:domain.umlproject.cadsr.nci.nih.gov'
    final String CADSRAPI_URI =
/*      'http://cadsrapi.nci.nih.gov/cadsrapi41/services/cadsrapi41Service' */
		'https://cadsrapi.nci.nih.gov/cadsrapi41/services/cadsrapi41Service'
    final String XSI_URI =
        'http://www.w3.org/2001/XMLSchema-instance'

    String[] preDeclaredNamespaceUris =
        [
            CADSR_URI,
            CADSRUML_URI,
            CADSRAPI_URI,
            XSI_URI
        ]

    def String getPreferredPrefix(
        String namespaceUri,
        String suggestion,
        boolean requirePrefix)
    {
        if(CADSR_URI.equals(namespaceUri))
        {
            return 'cadsr'
        }
        if(CADSRUML_URI.equals(namespaceUri))
        {
            return 'cadsruml'
        }
        if(CADSRAPI_URI.equals(namespaceUri))
        {
            return 'cadsrapi'
        }
        if(XSI_URI.equals(namespaceUri))
        {
            return 'xsi'
        }
        return suggestion
    }

    def String[] getPreDeclaredNamespaceUris()
    {
        return preDeclaredNamespaceUris
    }
}
